/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.PropRole
 *  fire.pb.activity.timernpc.TimerNpcService
 *  fire.pb.circletask.CircleTask
 *  fire.pb.circletask.anye.RoleAnYeTask
 *  fire.pb.clan.ClanUtils
 *  fire.pb.compensation.CompensationManager
 *  fire.pb.fushi.FushiManager
 *  fire.pb.main.ConfigManager
 *  fire.pb.map.Npc
 *  fire.pb.map.SceneNpcManager
 *  fire.pb.npc.NpcServiceCond.Condition
 *  fire.pb.school.shouxi.ProfessionLeaderManager
 *  gnet.link.Onlines
 *  mkdb.Procedure
 *  mkio.Protocol
 *  org.apache.log4j.Logger
 *  xbean.WeiBoNotify
 *  xtable.Role2weibonotify
 */
package fire.pb.npc;

import fire.pb.PropRole;
import fire.pb.activity.timernpc.TimerNpcService;
import fire.pb.circletask.CircleTask;
import fire.pb.circletask.anye.RoleAnYeTask;
import fire.pb.clan.ClanUtils;
import fire.pb.compensation.CompensationManager;
import fire.pb.fushi.FushiManager;
import fire.pb.main.ConfigManager;
import fire.pb.map.Npc;
import fire.pb.map.SceneNpcManager;
import fire.pb.npc.Module;
import fire.pb.npc.NpcServiceCond.Condition;
import fire.pb.npc.SAllConds;
import fire.pb.npc.SNpcCond;
import fire.pb.npc.SNpcServiceConfig;
import fire.pb.npc.SNpcServiceMapping;
import fire.pb.npc.SSendNpcMsg;
import fire.pb.npc.SServiceConds;
import fire.pb.school.shouxi.ProfessionLeaderManager;
import gnet.link.Onlines;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.NavigableMap;
import java.util.TreeMap;
import java.util.Vector;
import mkdb.Procedure;
import mkio.Protocol;
import org.apache.log4j.Logger;
import xbean.WeiBoNotify;
import xtable.Role2weibonotify;

public class NpcServiceManager {
    private static NpcServiceManager _instance = new NpcServiceManager();
    private static final Logger logger = Logger.getLogger((String)"MAPMAIN");
    private NavigableMap<Integer, SNpcServiceConfig> npcServiceMap = new TreeMap<Integer, SNpcServiceConfig>();
    private NavigableMap<Integer, SServiceConds> serviceDetailMap = new TreeMap<Integer, SServiceConds>();
    private NavigableMap<Integer, SNpcServiceMapping> npcServiceMappingMap = new TreeMap<Integer, SNpcServiceMapping>();
    private Map<Integer, Condition> allcondsmap = new HashMap<Integer, Condition>();
    private Vector<Integer> gmclosedservices = new Vector();

    private NpcServiceManager() {
    }

    public static synchronized NpcServiceManager getInstance() {
        return _instance;
    }

    /*
     * WARNING - Removed try catching itself - possible behaviour change.
     */
    public static void reload() throws Exception {
        NpcServiceManager instance = new NpcServiceManager();
        instance.init();
        Class<NpcServiceManager> clazz = NpcServiceManager.class;
        synchronized (NpcServiceManager.class) {
            _instance = instance;
            // ** MonitorExit[var1_1] (shouldn't be in output)
            return;
        }
    }

    void init() throws Exception {
        ConfigManager cm = ConfigManager.getInstance();
        this.npcServiceMap = cm.getConf(SNpcServiceConfig.class);
        logger.info((Object)("NPC服务配置表加载完毕。一共载入服务NPC" + this.npcServiceMap.size() + "个"));
        this.serviceDetailMap = cm.getConf(SServiceConds.class);
        logger.info((Object)("NPC服务描述表加载完毕。一共载入服务 " + this.serviceDetailMap.size() + "条"));
        this.npcServiceMappingMap = cm.getConf(SNpcServiceMapping.class);
        logger.info((Object)("NPC服务映射表加载完毕。一共载入服务映射" + this.npcServiceMappingMap.size() + "条"));
        this.registerAllConds(cm.getConf(SAllConds.class));
    }

    public void registerAllConds(NavigableMap<Integer, SAllConds> condsmap) {
        if (condsmap == null) {
            return;
        }
        Iterator iter = condsmap.keySet().iterator();
        while (iter.hasNext()) {
            int key = (Integer)iter.next();
            SAllConds cond = (SAllConds)condsmap.get(key);
            try {
                Condition condclass = (Condition)Class.forName("fire.pb.npc.NpcServiceCond." + cond.condname).getConstructor(new Class[0]).newInstance(new Object[0]);
                this.allcondsmap.put(key, condclass);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    public final SNpcServiceConfig getServiceConfigByNpcID(int npcid) {
        return (SNpcServiceConfig)this.npcServiceMap.get(npcid);
    }

    public final SNpcServiceMapping getServiceMappingByServiceID(int serviceid) {
        return (SNpcServiceMapping)this.npcServiceMappingMap.get(serviceid);
    }

    public void openService(Integer serviceid) {
        this.gmclosedservices.remove(serviceid);
    }

    public void closeService(Integer serviceid) {
        this.gmclosedservices.add(serviceid);
    }

    public boolean ingmclosedservice(Integer serviceid) {
        return this.gmclosedservices.contains(serviceid);
    }

    public static int getNpcIDByKey(long key) {
        Npc npc = SceneNpcManager.selectNpcByKey((long)key);
        if (null == npc) {
            return -1;
        }
        return npc.getNpcID();
    }

    private static final ArrayList<Integer> getDynamicServicesIDS(long npckey, long roleid) {
        ArrayList<Integer> result = new ArrayList<Integer>();
        Npc curnpc = SceneNpcManager.selectNpcByKey((long)npckey);
        if (curnpc == null) {
            logger.warn((Object)("role:" + roleid + "SceneNpcManager select npc=" + npckey + ",is null!"));
            return result;
        }
        int npcid = curnpc.getNpcID();
        try {
            CircleTask.addCTDynamicServices((long)roleid, (long)npckey, result);
            ProfessionLeaderManager.addDynamicServices((long)roleid, (long)npckey, (int)npcid, result);
            CompensationManager.getInstance().addDynamicServices(roleid, npcid, result);
            ClanUtils.addDynamicServices((long)roleid, (long)npckey, (int)npcid, result);
            TimerNpcService.addCTDynamicServices((long)roleid, (int)npcid, (long)npckey, result);
            Module.addDynamicServices(npcid, result);
        }
        catch (Exception e) {
            logger.error((Object)"exception when add dynamic service", (Throwable)e);
        }
        return result;
    }

    public final List<Integer> getServicesIDSByNpcKey(long roleid, long npckey) {
        return this.getServicesIDS(roleid, npckey, true);
    }

    public final List<Integer> getShowServicesIDSByNpcKey(long roleid, long npckey) {
        return this.getServicesIDS(roleid, npckey, false);
    }

    private final List<Integer> getServicesIDS(long roleid, long npckey, boolean getChildService) {
        ArrayList<Integer> results = new ArrayList<Integer>();
        ArrayList<Integer> dynamicResults = NpcServiceManager.getDynamicServicesIDS(npckey, roleid);
        results.addAll(dynamicResults);
        int npcid = NpcServiceManager.getNpcIDByKey(npckey);
        SNpcServiceConfig config = (SNpcServiceConfig)this.npcServiceMap.get(npcid);
        if (null != config && null != config.getServices()) {
            results.addAll(config.getServices());
        }
        ArrayList<Integer> toAdd = new ArrayList<Integer>();
        ArrayList<Integer> toRemove = new ArrayList<Integer>();
        Iterator iterator = results.iterator();
        while (iterator.hasNext()) {
            int serviceid = (Integer)iterator.next();
            if (!getChildService && !this.isServiceShow(roleid, serviceid)) {
                toRemove.add(serviceid);
                continue;
            }
            SServiceConds allconds = this.getServiceConds(serviceid);
            if (!getChildService || allconds == null || allconds.childservice == null) continue;
            toAdd.addAll(allconds.childservice);
        }
        if (getChildService) {
            results.addAll(toAdd);
        }
        if (!getChildService) {
            results.removeAll(toRemove);
        }
        if (npcid == 10964) {
            this.dealReturnFuShi(roleid, results);
        }
        results.removeAll(this.gmclosedservices);
        RoleAnYeTask.addDynamicServices((long)roleid, (long)npckey, results);
        return results;
    }

    private void dealReturnFuShi(long roleid, List<Integer> validlist) {
        WeiBoNotify notify;
        int userid = new PropRole(roleid, true).getUserid();
        int returnFuShi = FushiManager.getInstance().getFuShiFanHuan(userid);
        if (returnFuShi > 0) {
            validlist.add(1820);
        }
        if ((notify = Role2weibonotify.select((Long)roleid)) != null && notify.getTakeawardflag() == 1) {
            validlist.add(0, 1987);
        }
    }

    private boolean isServiceShow(long roleid, int serviceId) {
        SServiceConds allconds = this.getServiceConds(serviceId);
        if (allconds != null && !allconds.conditionids.isEmpty()) {
            for (SNpcCond cond : allconds.conditionids) {
                Condition condclass = this.allcondsmap.get(cond.condid);
                if (condclass == null) {
                    logger.debug((Object)("没有配置此id的条件  id=" + cond.condid));
                    return false;
                }
                if (condclass.CheckCond(roleid, cond.args1, cond.args2)) continue;
                return false;
            }
        }
        return true;
    }

    public SServiceConds getServiceConds(int serviceid) {
        return (SServiceConds)this.serviceDetailMap.get(serviceid);
    }

    public boolean hasServiceByNpcKey(long roleid, long npckey, int ... serviceids) {
        List<Integer> services = this.getServicesIDSByNpcKey(roleid, npckey);
        for (int serviceid : serviceids) {
            if (services.contains(serviceid)) continue;
            return false;
        }
        return true;
    }

    public static void sendNpcDialog(boolean proctrue, long roleid, long npckey, int msgid, ArrayList<Long> args) {
        if (null == args) {
            return;
        }
        Npc npc = SceneNpcManager.selectNpcByKey((long)npckey);
        if (null == npc) {
            return;
        }
        SSendNpcMsg send = new SSendNpcMsg();
        send.npcid = npc.getNpcID();
        send.npckey = npckey;
        send.msgid = msgid;
        send.args = args;
        if (proctrue) {
            Procedure.psendWhileCommit((long)roleid, (Protocol)send);
        } else {
            Procedure.psendWhileRollback((long)roleid, (Protocol)send);
        }
    }

    public static void sendNpcDialog(long roleid, long npckey, int msgid, ArrayList<Long> args) {
        if (null == args) {
            return;
        }
        Npc npc = SceneNpcManager.selectNpcByKey((long)npckey);
        if (null == npc) {
            return;
        }
        SSendNpcMsg send = new SSendNpcMsg();
        send.npcid = npc.getNpcID();
        send.npckey = npckey;
        send.msgid = msgid;
        send.args = args;
        Onlines.getInstance().send(Long.valueOf(roleid), (Protocol)send);
    }

    public static int transfNpcIDByKey(long npcKey) {
        Npc npc = SceneNpcManager.selectNpcByKey((long)npcKey);
        if (null == npc) {
            return -1;
        }
        return npc.getNpcID();
    }
}

